// 011 u_ci_square
// 03 jun 2004

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_ci_square;
  interface

    type i_compute= Interface
                        ['{0C5C2FE0-DD74-11D4-A354-005004125613}']
                        function set_side(p_side: Integer): HResult; stdcall;
                        function compute_area(var pv_area: Integer): HResult; stdcall;
                      end;
         i_journal= Interface
                      ['{C444E017-65B0-4AEB-B05C-6D473F1BE1EC}']
                      procedure write_to_journal;
                      procedure write_and_display;
                    end; // i_journal

         ci_square= class(TInterFacedObject, i_compute, i_journal)
                      m_side: Integer;
                      m_area: Integer;

                      constructor create;

                      function set_side(p_side: Integer): HResult; stdcall;
                      function compute_area(var pv_area: Integer): HResult; stdcall;

                      procedure write_to_journal;
                      procedure write_and_display; virtual;

                      procedure analyze;
                      procedure analyze_virtual; Virtual;

                      Destructor Destroy; Override;
                    end; // ci_square

  implementation
    uses u_c_display;

    constructor ci_square.create;
      begin
        m_side:= $1111;
        m_area:= $2222;
      end; // create

    function ci_square.set_side(p_side: Integer): HResult;
      begin
        m_side:= p_side;
      end; // set_side

    function ci_square.compute_area(var pv_area: Integer): HResult;
      begin
        pv_area:= m_side* m_side;
      end; // compute_area

    procedure ci_square.write_to_journal;
      begin
        display('ok');
      end; // write_to_journal

    procedure ci_square.write_and_display;
      begin
        display('write_and_display');
      end; // write_and_display

    procedure ci_square.analyze;
      begin
        m_side:= $7777;
      end; // analyze

    procedure ci_square.analyze_virtual;
      begin
        m_side:= $8888;
      end; // analyze_virtual

    Destructor ci_square.Destroy;
      begin
        Inherited;
      end; // Destroy

  end.
